Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveJobView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveJobView.cs	(revision 6033)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveJobView.cs	(revision 6168)
@@ -124,4 +124,5 @@
         if (Content != null && Content.Job != null) {
           this.stateTextBox.Text = Content.Job.State.ToString();
+          this.commandTextBox.Text = Content.Job.Command.ToString();
           this.executionTimeTextBox.Text = Content.Job.ExecutionTime.ToString();
           this.dateFinishedTextBox.Text = Content.Job.DateFinished.ToString();
@@ -137,4 +138,5 @@
         } else {
           this.stateTextBox.Text = string.Empty;
+          this.commandTextBox.Text = string.Empty;
           this.executionTimeTextBox.Text = string.Empty;
           this.dateCalculatedText.Text = string.Empty;
@@ -152,4 +154,5 @@
       this.jobIdTextBox.ReadOnly = true;
       this.stateTextBox.ReadOnly = true;
+      this.commandTextBox.ReadOnly = true;
       this.executionTimeTextBox.ReadOnly = true;
       this.dateCreatedTextBox.ReadOnly = true;
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveJobView.designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveJobView.designer.cs	(revision 6033)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveJobView.designer.cs	(revision 6168)
@@ -58,4 +58,6 @@
       this.jobIdTextBox = new System.Windows.Forms.TextBox();
       this.tabControl = new System.Windows.Forms.TabControl();
+      this.commandTextBox = new System.Windows.Forms.TextBox();
+      this.commandLabel = new System.Windows.Forms.Label();
       this.stateLogTabPage.SuspendLayout();
       this.detailsTabPage.SuspendLayout();
@@ -122,5 +124,5 @@
       // 
       this.splitContainer1.Panel2.Controls.Add(this.jobStatusGroupBox);
-      this.splitContainer1.Size = new System.Drawing.Size(551, 155);
+      this.splitContainer1.Size = new System.Drawing.Size(551, 178);
       this.splitContainer1.SplitterDistance = 275;
       this.splitContainer1.TabIndex = 33;
@@ -139,5 +141,5 @@
       this.configurationGroupBox.Location = new System.Drawing.Point(0, 0);
       this.configurationGroupBox.Name = "configurationGroupBox";
-      this.configurationGroupBox.Size = new System.Drawing.Size(275, 155);
+      this.configurationGroupBox.Size = new System.Drawing.Size(275, 178);
       this.configurationGroupBox.TabIndex = 27;
       this.configurationGroupBox.TabStop = false;
@@ -219,4 +221,6 @@
       // jobStatusGroupBox
       // 
+      this.jobStatusGroupBox.Controls.Add(this.commandTextBox);
+      this.jobStatusGroupBox.Controls.Add(this.commandLabel);
       this.jobStatusGroupBox.Controls.Add(this.stateTextBox);
       this.jobStatusGroupBox.Controls.Add(this.dateCalculatedLabel);
@@ -234,5 +238,5 @@
       this.jobStatusGroupBox.Location = new System.Drawing.Point(0, 0);
       this.jobStatusGroupBox.Name = "jobStatusGroupBox";
-      this.jobStatusGroupBox.Size = new System.Drawing.Size(272, 155);
+      this.jobStatusGroupBox.Size = new System.Drawing.Size(272, 178);
       this.jobStatusGroupBox.TabIndex = 24;
       this.jobStatusGroupBox.TabStop = false;
@@ -251,5 +255,5 @@
       // 
       this.dateCalculatedLabel.AutoSize = true;
-      this.dateCalculatedLabel.Location = new System.Drawing.Point(7, 85);
+      this.dateCalculatedLabel.Location = new System.Drawing.Point(7, 108);
       this.dateCalculatedLabel.Name = "dateCalculatedLabel";
       this.dateCalculatedLabel.Size = new System.Drawing.Size(83, 13);
@@ -270,5 +274,5 @@
       this.dateCalculatedText.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.dateCalculatedText.Location = new System.Drawing.Point(95, 85);
+      this.dateCalculatedText.Location = new System.Drawing.Point(95, 108);
       this.dateCalculatedText.Name = "dateCalculatedText";
       this.dateCalculatedText.Size = new System.Drawing.Size(171, 20);
@@ -279,5 +283,5 @@
       this.dateFinishedTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.dateFinishedTextBox.Location = new System.Drawing.Point(95, 107);
+      this.dateFinishedTextBox.Location = new System.Drawing.Point(95, 130);
       this.dateFinishedTextBox.Name = "dateFinishedTextBox";
       this.dateFinishedTextBox.Size = new System.Drawing.Size(171, 20);
@@ -288,5 +292,5 @@
       this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.executionTimeTextBox.Location = new System.Drawing.Point(95, 41);
+      this.executionTimeTextBox.Location = new System.Drawing.Point(95, 64);
       this.executionTimeTextBox.Name = "executionTimeTextBox";
       this.executionTimeTextBox.Size = new System.Drawing.Size(171, 20);
@@ -297,5 +301,5 @@
       this.dateCreatedTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.dateCreatedTextBox.Location = new System.Drawing.Point(95, 63);
+      this.dateCreatedTextBox.Location = new System.Drawing.Point(95, 86);
       this.dateCreatedTextBox.Name = "dateCreatedTextBox";
       this.dateCreatedTextBox.Size = new System.Drawing.Size(171, 20);
@@ -305,5 +309,5 @@
       // 
       this.executionTimeLabel.AutoSize = true;
-      this.executionTimeLabel.Location = new System.Drawing.Point(7, 41);
+      this.executionTimeLabel.Location = new System.Drawing.Point(7, 64);
       this.executionTimeLabel.Name = "executionTimeLabel";
       this.executionTimeLabel.Size = new System.Drawing.Size(80, 13);
@@ -314,5 +318,5 @@
       // 
       this.exceptionLabel.AutoSize = true;
-      this.exceptionLabel.Location = new System.Drawing.Point(7, 129);
+      this.exceptionLabel.Location = new System.Drawing.Point(7, 152);
       this.exceptionLabel.Name = "exceptionLabel";
       this.exceptionLabel.Size = new System.Drawing.Size(57, 13);
@@ -323,5 +327,5 @@
       // 
       this.dateCreatedLabel.AutoSize = true;
-      this.dateCreatedLabel.Location = new System.Drawing.Point(7, 63);
+      this.dateCreatedLabel.Location = new System.Drawing.Point(7, 86);
       this.dateCreatedLabel.Name = "dateCreatedLabel";
       this.dateCreatedLabel.Size = new System.Drawing.Size(70, 13);
@@ -332,5 +336,5 @@
       // 
       this.dateFinishedLabel.AutoSize = true;
-      this.dateFinishedLabel.Location = new System.Drawing.Point(7, 107);
+      this.dateFinishedLabel.Location = new System.Drawing.Point(7, 130);
       this.dateFinishedLabel.Name = "dateFinishedLabel";
       this.dateFinishedLabel.Size = new System.Drawing.Size(72, 13);
@@ -342,5 +346,5 @@
       this.exceptionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.exceptionTextBox.Location = new System.Drawing.Point(95, 129);
+      this.exceptionTextBox.Location = new System.Drawing.Point(95, 152);
       this.exceptionTextBox.Name = "exceptionTextBox";
       this.exceptionTextBox.Size = new System.Drawing.Size(171, 20);
@@ -435,4 +439,22 @@
       this.tabControl.Size = new System.Drawing.Size(571, 401);
       this.tabControl.TabIndex = 25;
+      // 
+      // commandTextBox
+      // 
+      this.commandTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.commandTextBox.Location = new System.Drawing.Point(95, 41);
+      this.commandTextBox.Name = "commandTextBox";
+      this.commandTextBox.Size = new System.Drawing.Size(171, 20);
+      this.commandTextBox.TabIndex = 24;
+      // 
+      // commandLabel
+      // 
+      this.commandLabel.AutoSize = true;
+      this.commandLabel.Location = new System.Drawing.Point(7, 41);
+      this.commandLabel.Name = "commandLabel";
+      this.commandLabel.Size = new System.Drawing.Size(57, 13);
+      this.commandLabel.TabIndex = 25;
+      this.commandLabel.Text = "Command:";
       // 
       // HiveJobView
@@ -497,4 +519,6 @@
     protected System.Windows.Forms.Label dateCreatedLabel;
     protected System.Windows.Forms.SplitContainer splitContainer1;
+    protected System.Windows.Forms.TextBox commandTextBox;
+    protected System.Windows.Forms.Label commandLabel;
 
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/OptimizerHiveJobView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/OptimizerHiveJobView.cs	(revision 6033)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/OptimizerHiveJobView.cs	(revision 6168)
@@ -54,7 +54,7 @@
       base.SetEnabledStateOfControls();
 
-      this.restartButton.Enabled = Content != null && Content.Job.State == JobState.Paused;
-      this.pauseButton.Enabled = Content != null && Content.Job.State == JobState.Calculating;
-      this.stopButton.Enabled = Content != null && (Content.Job.State == JobState.Calculating || Content.Job.State == JobState.Waiting || Content.Job.State == JobState.Paused);
+      this.restartButton.Enabled = Content != null && !Content.Job.Command.HasValue && Content.Job.State == JobState.Paused;
+      this.pauseButton.Enabled = Content != null && !Content.Job.Command.HasValue && Content.Job.State == JobState.Calculating;
+      this.stopButton.Enabled = Content != null && !Content.Job.Command.HasValue && (Content.Job.State == JobState.Calculating || Content.Job.State == JobState.Waiting || Content.Job.State == JobState.Paused);
     }
     #endregion
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/StateLogGanttChartListView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/StateLogGanttChartListView.cs	(revision 6033)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/StateLogGanttChartListView.cs	(revision 6168)
@@ -64,5 +64,10 @@
         if (Content.Count > 0) {
           DateTime maxValue = Content.Max(x => x.Count > 0 ? x.Max(y => y.DateTime) : DateTime.MinValue);
-          var upperLimit = DateTime.FromOADate(Math.Min(DateTime.Now.AddSeconds(10).ToOADate(), maxValue.AddSeconds(10).ToOADate()));
+          DateTime upperLimit;
+          if (Content.All(x => x.Count > 0 ? (x.Last().State == JobState.Finished || x.Last().State == JobState.Failed || x.Last().State == JobState.Aborted) : true)) {
+            upperLimit = DateTime.FromOADate(Math.Min(DateTime.Now.AddSeconds(10).ToOADate(), maxValue.AddSeconds(10).ToOADate()));
+          } else {
+            upperLimit = DateTime.Now;
+          }
 
           for (int i = 0; i < Content.Count; i++) {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/StateLogGanttChartView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/StateLogGanttChartView.cs	(revision 6033)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/StateLogGanttChartView.cs	(revision 6168)
@@ -62,5 +62,10 @@
         StateLogGanttChartListView.SetupCategories(ganttChart);
         if (Content.Count > 0) {
-          var upperLimit = DateTime.FromOADate(Math.Min(Content.Max(x => x.DateTime).ToOADate(), DateTime.Now.AddSeconds(10).ToOADate()));
+          DateTime upperLimit;
+          if(Content.Last().State == JobState.Finished || Content.Last().State == JobState.Failed || Content.Last().State == JobState.Aborted) {
+            upperLimit = DateTime.FromOADate(Math.Min(Content.Max(x => x.DateTime).ToOADate(), DateTime.Now.AddSeconds(10).ToOADate()));
+          } else {
+            upperLimit = DateTime.Now;
+          }
 
           for (int i = 0; i < Content.Count - 1; i++) {