Index: trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLab.Hive.log4net.xml
===================================================================
--- trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLab.Hive.log4net.xml	(revision 6099)
+++ 	(revision )
@@ -1,66 +1,0 @@
-﻿<log4net>
-  
-  <appender name="RollingFileAppender" type="log4net.Appender.RollingFileAppender">
-    <file value="Hive.log" />
-    <appendToFile value="true" />
-    <rollingStyle value="Size" />
-    <maxSizeRollBackups value="10" />
-    <maximumFileSize value="1000KB" />
-    <staticLogFileName value="true" />
-    <lockingModel type="log4net.Appender.FileAppender+MinimalLock" />
-    <layout type="HeuristicLab.Tracing.MethodCallPatternLayout, HeuristicLab.Tracing-3.2">
-      <conversionPattern value="%date{yyyy-MM-dd HH:mm:ss.ffff} %-4timestamp %-5level %logger.%RM - %message%newline%exception" />
-    </layout>
-  </appender>
-
-  <appender name="ServerRollingFileAppender" type="log4net.Appender.RollingFileAppender">
-    <file value="Hive.Server.log" />
-    <appendToFile value="true" />
-    <rollingStyle value="Size" />
-    <maxSizeRollBackups value="10" />
-    <maximumFileSize value="1000KB" />
-    <staticLogFileName value="true" />
-    <lockingModel type="log4net.Appender.FileAppender+MinimalLock" />
-    <layout type="HeuristicLab.Tracing.MethodCallPatternLayout, HeuristicLab.Tracing-3.2">
-      <conversionPattern value="%date{yyyy-MM-dd HH:mm:ss.ffff} %-4timestamp %-5level %logger.%RM - %message%newline%exception" />
-    </layout>
-  </appender>
-
-  <appender name="ClientRollingFileAppender" type="log4net.Appender.RollingFileAppender">
-    <file value="Hive.Client.log" />
-    <appendToFile value="true" />
-    <rollingStyle value="Size" />
-    <maxSizeRollBackups value="10" />
-    <maximumFileSize value="1000KB" />
-    <staticLogFileName value="true" />
-    <lockingModel type="log4net.Appender.FileAppender+MinimalLock" />
-    <layout type="HeuristicLab.Tracing.MethodCallPatternLayout, HeuristicLab.Tracing-3.2">
-      <conversionPattern value="%date{yyyy-MM-dd HH:mm:ss.ffff} %-4timestamp %-5level %logger.%RM - %message%newline%exception" />
-    </layout>
-  </appender>
-  
-  <appender name="BufferingForwardingAppender" type="log4net.Appender.BufferingForwardingAppender" >
-    <bufferSize value="128" />
-    <lossy value="true" />
-    <evaluator type="log4net.Core.LevelEvaluator">
-        <threshold value="DEBUG"/>
-    </evaluator>
-    <appender-ref ref="RollingFileAppender" />
-  </appender>
-  
-  <root>
-    <level value="INFO" />
-    <appender-ref ref="BufferingForwardingAppender" />
-  </root>
-
-  <logger name="HeuristicLab.Hive.Server">
-    <level value="DEBUG" />
-    <appender-ref ref="ServerRollingFileAppender" />    
-  </logger>
-
-  <logger name="HeuristicLab.Hive.Client">
-    <level value="DEBUG" />
-    <appender-ref ref="ClientRollingFileAppender" />  
-  </logger>
-  
-</log4net>
Index: trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLab.Tracing-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLab.Tracing-3.3.csproj	(revision 6099)
+++ trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLab.Tracing-3.3.csproj	(revision 6173)
@@ -96,8 +96,4 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="log4net, Version=1.2.10.0, Culture=neutral, PublicKeyToken=1b44e1d426115821, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\HeuristicLab.ExtLibs\HeuristicLab.log4net\1.2.10.0\log4net.dll</HintPath>
-    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -115,7 +111,6 @@
   <ItemGroup>
     <None Include="HeuristicLabTracingPlugin.cs.frame" />
-    <Compile Include="HiveLogger.cs" />
+    <Compile Include="HeuristicLabTracingPlugin.cs" />
     <Compile Include="Logger.cs" />
-    <Compile Include="HeuristicLabTracingPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
@@ -126,8 +121,4 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.ExtLibs\HeuristicLab.log4net\1.2.10.0\HeuristicLab.log4net-1.2.10.0.csproj">
-      <Project>{1B3063DB-D71C-4A6A-A359-883E8F53A140}</Project>
-      <Name>HeuristicLab.log4net-1.2.10.0</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
       <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
@@ -143,12 +134,4 @@
       <LastGenOutput>Settings.Designer.cs</LastGenOutput>
     </None>
-    <Content Include="HeuristicLab.log4net.xml">
-      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
-    </Content>
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="HeuristicLab.Hive.log4net.xml">
-      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
-    </Content>
   </ItemGroup>
   <ItemGroup>
Index: trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLab.log4net.xml
===================================================================
--- trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLab.log4net.xml	(revision 6099)
+++ 	(revision )
@@ -1,30 +1,0 @@
-﻿<log4net>
-  
-  <appender name="RollingFileAppender" type="log4net.Appender.RollingFileAppender">
-    <file value="HeuristicLab.log" />
-    <appendToFile value="true" />
-    <rollingStyle value="Size" />
-    <maxSizeRollBackups value="10" />
-    <maximumFileSize value="100KB" />
-    <staticLogFileName value="true" />
-    <lockingModel type="log4net.Appender.FileAppender+MinimalLock" />
-    <layout type="log4net.Layout.PatternLayout">
-      <conversionPattern value="%-4timestamp [%appdomain/%thread] %-5level %logger %ndc - %message%newline%exception" />
-    </layout>
-  </appender>
-  
-  <appender name="BufferingForwardingAppender" type="log4net.Appender.BufferingForwardingAppender" >
-    <bufferSize value="128" />
-    <lossy value="true" />
-    <evaluator type="log4net.Core.LevelEvaluator">
-        <threshold value="INFO"/>
-    </evaluator>
-    <appender-ref ref="RollingFileAppender" />
-  </appender>
-  
-  <root>
-    <level value="INFO" />
-    <appender-ref ref="BufferingForwardingAppender" />
-  </root>
-  
-</log4net>
Index: trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLabTracingPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLabTracingPlugin.cs.frame	(revision 6099)
+++ trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLabTracingPlugin.cs.frame	(revision 6173)
@@ -29,6 +29,4 @@
   [Plugin("HeuristicLab.Tracing", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Tracing-3.3.dll", PluginFileType.Assembly)]
-  [PluginFile("HeuristicLab.log4net.xml", PluginFileType.Data)]
-  [PluginDependency("HeuristicLab.log4net", "1.2.10.0")]
   public class HeuristicLabPersistencePlugin : PluginBase {}
 
Index: trunk/sources/HeuristicLab.Tracing/3.3/HiveLogger.cs
===================================================================
--- trunk/sources/HeuristicLab.Tracing/3.3/HiveLogger.cs	(revision 6099)
+++ 	(revision )
@@ -1,147 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Diagnostics;
-using System.IO;
-using HeuristicLab.Tracing.Properties;
-using log4net;
-using log4net.Config;
-
-namespace HeuristicLab.Tracing {
-  public class HiveLogger {
-    protected static bool IsConfigured = false;
-    protected static void Configure() {
-      if (IsConfigured) return;
-      IsConfigured = true;
-      if (string.IsNullOrEmpty(Settings.Default.TracingLog4netConfigFile)) {
-        Settings.Default.TracingLog4netConfigFile =
-            "HeuristicLab.Hive.log4net.xml";
-      }
-      XmlConfigurator.ConfigureAndWatch(
-        new FileInfo(Settings.Default.TracingLog4netConfigFile));
-      Info("Hive Logging initialized " + DateTime.Now);
-    }
-
-    public static ILog GetDefaultLogger(int nParents) {
-      Configure();
-      StackFrame frame = new StackFrame(nParents + 1);
-      return LogManager.GetLogger(frame.GetMethod().DeclaringType);
-    }
-
-    public static ILog GetDefaultLogger() {
-      Configure();
-      StackFrame frame = new StackFrame(1);
-      return LogManager.GetLogger(frame.GetMethod().DeclaringType);
-    }
-
-    public static void Debug(object message) {
-      GetDefaultLogger(1).Debug(DateTime.Now + ":" + DateTime.Now.Millisecond + " - " + message);
-    }
-
-    public static void Info(object message) {
-      GetDefaultLogger(1).Info(DateTime.Now + ":" + DateTime.Now.Millisecond + " - " + message);
-    }
-
-    public static void Warn(object message) {
-      GetDefaultLogger(1).Warn(DateTime.Now + ":" + DateTime.Now.Millisecond + " - " + message);
-    }
-
-    public static void Error(object message) {
-      GetDefaultLogger(1).Error(DateTime.Now + ":" + DateTime.Now.Millisecond + " - " + message);
-    }
-
-    public static void Fatal(object message) {
-      GetDefaultLogger(1).Fatal(DateTime.Now + ":" + DateTime.Now.Millisecond + " - " + message);
-    }
-
-    public static void Debug(Type type, object message) {
-      Configure();
-      LogManager.GetLogger(type).Debug(message);
-    }
-
-    public static void Info(Type type, object message) {
-      Configure();
-      LogManager.GetLogger(type).Info(message);
-    }
-
-    public static void Warn(Type type, object message) {
-      Configure();
-      LogManager.GetLogger(type).Warn(message);
-    }
-
-    public static void Error(Type type, object message) {
-      Configure();
-      LogManager.GetLogger(type).Error(message);
-    }
-
-    public static void Fatal(Type type, object message) {
-      Configure();
-      LogManager.GetLogger(type).Fatal(message);
-    }
-
-    public static void Debug(object message, Exception exception) {
-      GetDefaultLogger(1).Debug(message, exception);
-    }
-
-    public static void Info(object message, Exception exception) {
-      GetDefaultLogger(1).Info(message, exception);
-    }
-
-    public static void Warn(object message, Exception exception) {
-      GetDefaultLogger(1).Warn(message, exception);
-    }
-
-    public static void Error(object message, Exception exception) {
-      GetDefaultLogger(1).Error(message, exception);
-    }
-
-    public static void Fatal(object message, Exception exception) {
-      GetDefaultLogger(1).Fatal(message, exception);
-    }
-
-    public static void Debug(Type type, object message, Exception exception) {
-      Configure();
-      LogManager.GetLogger(type).Debug(message, exception);
-    }
-
-    public static void Info(Type type, object message, Exception exception) {
-      Configure();
-      LogManager.GetLogger(type).Info(message, exception);
-    }
-
-    public static void Warn(Type type, object message, Exception exception) {
-      Configure();
-      LogManager.GetLogger(type).Warn(message, exception);
-    }
-
-    public static void Error(Type type, object message, Exception exception) {
-      Configure();
-      LogManager.GetLogger(type).Error(message, exception);
-    }
-
-    public static void Fatal(Type type, object message, Exception exception) {
-      Configure();
-      LogManager.GetLogger(type).Fatal(message, exception);
-    }
-
-  }
-}
Index: trunk/sources/HeuristicLab.Tracing/3.3/Logger.cs
===================================================================
--- trunk/sources/HeuristicLab.Tracing/3.3/Logger.cs	(revision 6099)
+++ trunk/sources/HeuristicLab.Tracing/3.3/Logger.cs	(revision 6173)
@@ -20,210 +20,126 @@
 #endregion
 
+
 using System;
 using System.Diagnostics;
-using System.IO;
-using HeuristicLab.Tracing.Properties;
-using log4net;
-using log4net.Config;
-
 namespace HeuristicLab.Tracing {
 
   /// <summary>
-  /// HeuristicLab Tracing entry point. Default logger. Reads configured tracing
-  /// file and provides automatic logging with reflection of the calling type.
+  /// HeuristicLab.Tracing using System.Diagnostics.Trace.
+  /// Note that tracing is only activated if the DEBUG or TRACE symbol is set. 
+  /// Configuration (type of listener, file name, ...) is done in app.config in the <system.diagnostics> section. 
   /// </summary>
   public class Logger {
 
     /// <summary>
-    /// true if Configure has been called already.
+    /// Issues a debug message.
     /// </summary>
-    protected static bool IsConfigured = false;
-
-    /// <summary>
-    /// Configures this instance: Reads the log file specified in the settings.
-    /// </summary>
-    protected static void Configure() {
-      if (IsConfigured) return;
-      IsConfigured = true;
-      if (string.IsNullOrEmpty(Settings.Default.TracingLog4netConfigFile)) {
-        Settings.Default.TracingLog4netConfigFile =
-            "HeuristicLab.log4net.xml";
-      }
-      XmlConfigurator.ConfigureAndWatch(
-        new FileInfo(Settings.Default.TracingLog4netConfigFile));
-      Info("logging initialized " + DateTime.Now);
+    /// <param name="message">The message.</param>
+    public static void Debug(object message) {
+      StackFrame frame = new StackFrame(1);
+      Trace.TraceInformation(frame.GetMethod().DeclaringType.ToString() + " - " + message.ToString());
     }
 
     /// <summary>
-    /// Gets the default logger for the calling class n levels up in the
-    /// call hierarchy.
+    /// Issues an informational message. 
     /// </summary>
-    /// <param name="nParents">The number of parent calls.</param>
-    /// <returns>An <see cref="ILog"/> instance.</returns>
-    public static ILog GetDefaultLogger(int nParents) {
-      Configure();
-      StackFrame frame = new StackFrame(nParents + 1);
-      return LogManager.GetLogger(frame.GetMethod().DeclaringType);
+    /// <param name="message">The message.</param>
+    public static void Info(object message) {
+      StackFrame frame = new StackFrame(1);
+      Trace.TraceInformation(frame.GetMethod().DeclaringType.ToString() + " - " + message.ToString());
     }
 
     /// <summary>
-    /// Gets the default logger: The logger for the class of the
-    /// calling method.
+    /// Issues a warning message.
     /// </summary>
-    /// <returns>An <see cref="ILog"/> instance.</returns>
-    public static ILog GetDefaultLogger() {
-      Configure();
+    /// <param name="message">The message.</param>
+    public static void Warn(object message) {
       StackFrame frame = new StackFrame(1);
-      return LogManager.GetLogger(frame.GetMethod().DeclaringType);
+      Trace.TraceWarning(frame.GetMethod().DeclaringType.ToString() + " - " + message.ToString());
     }
 
     /// <summary>
-    /// Issues a debug message to the default logger.
+    /// Issues an error message.
     /// </summary>
     /// <param name="message">The message.</param>
-    public static void Debug(object message) {
-      GetDefaultLogger(1).Debug(message);
+    public static void Error(object message) {
+      StackFrame frame = new StackFrame(1);
+      Trace.TraceError(frame.GetMethod().DeclaringType.ToString() + " - " + message.ToString());
     }
 
     /// <summary>
-    /// Issues an informational message to the default logger.
-    /// </summary>
-    /// <param name="message">The message.</param>
-    public static void Info(object message) {
-      GetDefaultLogger(1).Info(message);
-    }
-
-    /// <summary>
-    /// Issues a warning message to the default logger.
-    /// </summary>
-    /// <param name="message">The message.</param>
-    public static void Warn(object message) {
-      GetDefaultLogger(1).Warn(message);
-    }
-
-    /// <summary>
-    /// Issues an error message to the default logger.
-    /// </summary>
-    /// <param name="message">The message.</param>
-    public static void Error(object message) {
-      GetDefaultLogger(1).Error(message);
-    }
-
-    /// <summary>
-    /// Issues a fatal error message to the default logger.
-    /// </summary>
-    /// <param name="message">The message.</param>
-    public static void Fatal(object message) {
-      GetDefaultLogger(1).Fatal(message);
-    }
-
-    /// <summary>
-    /// Issues a debug message to the logger of the specified type.
+    /// Issues a debug message of the specified type.
     /// </summary>
     /// <param name="type">The type.</param>
     /// <param name="message">The message.</param>
     public static void Debug(Type type, object message) {
-      Configure();
-      LogManager.GetLogger(type).Debug(message);
+      Trace.TraceInformation(type.ToString() + ": " + message.ToString());
     }
 
     /// <summary>
-    /// Issues an iformational message to the logger of the specified
-    /// type.
+    /// Issues an informational message of the specified type.
     /// </summary>
     /// <param name="type">The type.</param>
     /// <param name="message">The message.</param>
     public static void Info(Type type, object message) {
-      Configure();
-      LogManager.GetLogger(type).Info(message);
+      Trace.TraceInformation(type.ToString() + ": " + message.ToString());
     }
 
     /// <summary>
-    /// Issues a warning message to the logger of
-    /// the specified type.
+    /// Issues a warning message of the specified type.
     /// </summary>
     /// <param name="type">The type.</param>
     /// <param name="message">The message.</param>
     public static void Warn(Type type, object message) {
-      Configure();
-      LogManager.GetLogger(type).Warn(message);
+      Trace.TraceWarning(type.ToString() + ": " + message.ToString());
     }
 
     /// <summary>
-    /// Issues an error message to the logger of the specified
-    /// type.
+    /// Issues an error message of the specified type.
     /// </summary>
     /// <param name="type">The type.</param>
     /// <param name="message">The message.</param>
     public static void Error(Type type, object message) {
-      Configure();
-      LogManager.GetLogger(type).Error(message);
+      Trace.TraceError(type.ToString() + ": " + message.ToString());
     }
 
     /// <summary>
-    /// Issues a fatal error message to the logger of
-    /// the specified type.
-    /// </summary>
-    /// <param name="type">The type.</param>
-    /// <param name="message">The message.</param>
-    public static void Fatal(Type type, object message) {
-      Configure();
-      LogManager.GetLogger(type).Fatal(message);
-    }
-
-    /// <summary>
-    /// Issues a debug message to the default
-    /// logger including an exception.
+    /// Issues a debug message including an exception.
     /// </summary>
     /// <param name="message">The message.</param>
     /// <param name="exception">The exception.</param>
     public static void Debug(object message, Exception exception) {
-      GetDefaultLogger(1).Debug(message, exception);
+      Trace.TraceInformation(message.ToString() + ": " + exception.ToString());
     }
 
     /// <summary>
-    /// Issues an informational message to the default
-    /// logger including an exception.
+    /// Issues an informational message including an exception.
     /// </summary>
     /// <param name="message">The message.</param>
-    /// <param name="exception">The exception.</param>
-
+    /// <param name="exception">The exception.</param>        
     public static void Info(object message, Exception exception) {
-      GetDefaultLogger(1).Info(message, exception);
+      Trace.TraceInformation(message.ToString() + ": " + exception.ToString());
     }
 
     /// <summary>
-    /// Issues a warning message to the default
-    /// logger including an exception.
+    /// Issues a warning message including an exception.
     /// </summary>
     /// <param name="message">The message.</param>
     /// <param name="exception">The exception.</param>
     public static void Warn(object message, Exception exception) {
-      GetDefaultLogger(1).Warn(message, exception);
+      Trace.TraceWarning(message.ToString() + ": " + exception.ToString());
     }
 
     /// <summary>
-    /// Issues an error message to the default
-    /// logger including an exception.
+    /// Issues an error message including an exception.
     /// </summary>
     /// <param name="message">The message.</param>
     /// <param name="exception">The exception.</param>
     public static void Error(object message, Exception exception) {
-      GetDefaultLogger(1).Error(message, exception);
+      Trace.TraceError(message.ToString() + ": " + exception.ToString());
     }
 
     /// <summary>
-    /// Issues a fatal error message to the default
-    /// logger including an exception.
-    /// </summary>
-    /// <param name="message">The message.</param>
-    /// <param name="exception">The exception.</param>
-    public static void Fatal(object message, Exception exception) {
-      GetDefaultLogger(1).Fatal(message, exception);
-    }
-
-    /// <summary>
-    /// Issues a debug message to the logger of the specified
-    /// type including an exception.
+    /// Issues a debug message of the specified type including an exception.
     /// </summary>
     /// <param name="type">The type.</param>
@@ -231,11 +147,9 @@
     /// <param name="exception">The exception.</param>
     public static void Debug(Type type, object message, Exception exception) {
-      Configure();
-      LogManager.GetLogger(type).Debug(message, exception);
+      Trace.TraceInformation(type.ToString() + ": " + message.ToString() + ": " + exception.ToString());
     }
 
     /// <summary>
-    /// Issues an informational message to the logger of the specified
-    /// type including an exception.
+    /// Issues an informational message of the specified type including an exception.
     /// </summary>
     /// <param name="type">The type.</param>
@@ -243,11 +157,9 @@
     /// <param name="exception">The exception.</param>
     public static void Info(Type type, object message, Exception exception) {
-      Configure();
-      LogManager.GetLogger(type).Info(message, exception);
+      Trace.TraceInformation(type.ToString() + ": " + message.ToString() + ": " + exception.ToString());
     }
 
     /// <summary>
-    /// Issues a warning message to the logger of the specified
-    /// type including an exception.
+    /// Issues a warning message of the specified type including an exception.
     /// </summary>
     /// <param name="type">The type.</param>
@@ -255,11 +167,9 @@
     /// <param name="exception">The exception.</param>
     public static void Warn(Type type, object message, Exception exception) {
-      Configure();
-      LogManager.GetLogger(type).Warn(message, exception);
+      Trace.TraceWarning(type.ToString() + ": " + message.ToString() + ": " + exception.ToString());
     }
 
     /// <summary>
-    /// Issues an error message to the logger of the specified
-    /// type including an exception.
+    /// Issues an error message of the specified type including an exception.
     /// </summary>
     /// <param name="type">The type.</param>
@@ -267,18 +177,5 @@
     /// <param name="exception">The exception.</param>
     public static void Error(Type type, object message, Exception exception) {
-      Configure();
-      LogManager.GetLogger(type).Error(message, exception);
-    }
-
-    /// <summary>
-    /// Issues a fatal error message to the logger of the specified
-    /// type including an exception.
-    /// </summary>
-    /// <param name="type">The type.</param>
-    /// <param name="message">The message.</param>
-    /// <param name="exception">The exception.</param>
-    public static void Fatal(Type type, object message, Exception exception) {
-      Configure();
-      LogManager.GetLogger(type).Fatal(message, exception);
+      Trace.TraceError(type.ToString() + ": " + message.ToString() + ": " + exception.ToString());
     }
   }
Index: trunk/sources/HeuristicLab.Tracing/3.3/Properties/Settings.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Tracing/3.3/Properties/Settings.Designer.cs	(revision 6099)
+++ trunk/sources/HeuristicLab.Tracing/3.3/Properties/Settings.Designer.cs	(revision 6173)
@@ -2,5 +2,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:4.0.30319.1
+//     Runtime Version:4.0.30319.225
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -23,16 +23,4 @@
             }
         }
-        
-        [global::System.Configuration.UserScopedSettingAttribute()]
-        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("")]
-        public string TracingLog4netConfigFile {
-            get {
-                return ((string)(this["TracingLog4netConfigFile"]));
-            }
-            set {
-                this["TracingLog4netConfigFile"] = value;
-            }
-        }
     }
 }
Index: trunk/sources/HeuristicLab.Tracing/3.3/Properties/Settings.settings
===================================================================
--- trunk/sources/HeuristicLab.Tracing/3.3/Properties/Settings.settings	(revision 6099)
+++ trunk/sources/HeuristicLab.Tracing/3.3/Properties/Settings.settings	(revision 6173)
@@ -3,7 +3,5 @@
   <Profiles />
   <Settings>
-    <Setting Name="TracingLog4netConfigFile" Type="System.String" Scope="User">
-      <Value Profile="(Default)" />
-    </Setting>
+   
   </Settings>
 </SettingsFile>
Index: trunk/sources/HeuristicLab.Tracing/3.3/app.config
===================================================================
--- trunk/sources/HeuristicLab.Tracing/3.3/app.config	(revision 6099)
+++ trunk/sources/HeuristicLab.Tracing/3.3/app.config	(revision 6173)
@@ -1,4 +1,14 @@
 <?xml version="1.0"?>
-<configuration>
+<configuration>        
+  <system.diagnostics>
+    <trace autoflush="true" indentsize="4">
+      <listeners>
+        <add name="HeuristicLabListener"
+          type="System.Diagnostics.TextWriterTraceListener"
+          initializeData="HeuristicLab.log" />
+        <remove name="Default" />
+      </listeners>
+    </trace>
+  </system.diagnostics>
   <configSections>    
     <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
@@ -8,7 +18,5 @@
   <userSettings>
     <HeuristicLab.Tracing.Properties.Settings>
-      <setting name="TracingLog4netConfigFile" serializeAs="String">
-        <value/>
-      </setting>
+    
     </HeuristicLab.Tracing.Properties.Settings>
   </userSettings>