Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/DataTableView.Designer.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/DataTableView.Designer.cs	(revision 6175)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/DataTableView.Designer.cs	(revision 6176)
@@ -89,5 +89,4 @@
       series1.Name = "Default";
       this.chart.Series.Add(series1);
-      this.chart.ShowPropertiesContextMenuItem = true;
       this.chart.Size = new System.Drawing.Size(359, 248);
       this.chart.TabIndex = 3;
@@ -97,5 +96,4 @@
       title1.Text = "Title";
       this.chart.Titles.Add(title1);
-      this.chart.PropertiesClicked += new System.EventHandler(this.chart_PropertiesClicked);
       this.chart.CustomizeLegend += new System.EventHandler<System.Windows.Forms.DataVisualization.Charting.CustomizeLegendEventArgs>(this.chart_CustomizeLegend);
       this.chart.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown);
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/DataTableView.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/DataTableView.cs	(revision 6175)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/DataTableView.cs	(revision 6176)
@@ -36,5 +36,5 @@
   [View("DataTable View")]
   [Content(typeof(DataTable), true)]
-  public partial class DataTableView : NamedItemView {
+  public partial class DataTableView : NamedItemView, IConfigureableView {
     protected List<Series> invisibleSeries;
     protected Dictionary<IObservableList<double>, DataRow> valuesRowsTable;
@@ -144,4 +144,11 @@
       base.SetEnabledStateOfControls();
       chart.Enabled = Content != null;
+    }
+
+    public void ShowConfiguration() {
+      if (Content != null) {
+        DataTableVisualPropertiesDialog dialog = new DataTableVisualPropertiesDialog(Content);
+        dialog.ShowDialog();
+      } else MessageBox.Show("Nothing to configure.");
     }
 
@@ -503,8 +510,4 @@
       }
     }
-    private void chart_PropertiesClicked(object sender, EventArgs e) {
-      DataTableVisualPropertiesDialog dialog = new DataTableVisualPropertiesDialog(Content);
-      dialog.ShowDialog();
-    }
     #endregion
 
Index: /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/EnhancedChart.Designer.cs
===================================================================
--- /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/EnhancedChart.Designer.cs	(revision 6175)
+++ /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/EnhancedChart.Designer.cs	(revision 6176)
@@ -50,6 +50,4 @@
       this.copyImageToClipboardBitmapToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
-      this.propertiesToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.propertiesToolStripSeparator = new System.Windows.Forms.ToolStripSeparator();
       this.contextMenuStrip.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this)).BeginInit();
@@ -60,10 +58,7 @@
       this.contextMenuStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
             this.exportChartToolStripMenuItem,
-            this.copyImageToClipboardBitmapToolStripMenuItem,
-            this.propertiesToolStripSeparator,
-            this.propertiesToolStripMenuItem});
+            this.copyImageToClipboardBitmapToolStripMenuItem});
       this.contextMenuStrip.Name = "contextMenuStrip";
       this.contextMenuStrip.Size = new System.Drawing.Size(257, 76);
-      this.contextMenuStrip.Opening += new System.ComponentModel.CancelEventHandler(this.contextMenuStrip_Opening);
       // 
       // exportChartToolStripMenuItem
@@ -87,16 +82,4 @@
       this.saveFileDialog.FilterIndex = 2;
       // 
-      // propertiesToolStripMenuItem
-      // 
-      this.propertiesToolStripMenuItem.Name = "propertiesToolStripMenuItem";
-      this.propertiesToolStripMenuItem.Size = new System.Drawing.Size(256, 22);
-      this.propertiesToolStripMenuItem.Text = "Properties";
-      this.propertiesToolStripMenuItem.Click += new System.EventHandler(this.propertiesToolStripMenuItem_Click);
-      // 
-      // propertiesToolStripSeparator
-      // 
-      this.propertiesToolStripSeparator.Name = "propertiesToolStripSeparator";
-      this.propertiesToolStripSeparator.Size = new System.Drawing.Size(253, 6);
-      // 
       // EnhancedChart
       // 
@@ -114,6 +97,4 @@
     private System.Windows.Forms.ToolStripMenuItem copyImageToClipboardBitmapToolStripMenuItem;
     private System.Windows.Forms.SaveFileDialog saveFileDialog;
-    private System.Windows.Forms.ToolStripSeparator propertiesToolStripSeparator;
-    private System.Windows.Forms.ToolStripMenuItem propertiesToolStripMenuItem;
   }
 }
Index: /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/EnhancedChart.cs
===================================================================
--- /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/EnhancedChart.cs	(revision 6175)
+++ /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/EnhancedChart.cs	(revision 6176)
@@ -25,5 +25,4 @@
 using System.Windows.Forms;
 using System.Windows.Forms.DataVisualization.Charting;
-using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.Visualization.ChartControlsExtensions {
@@ -32,5 +31,4 @@
       : base() {
       InitializeComponent();
-      propertiesToolStripMenuItem.Image = VSImageLibrary.Properties;
       EnableDoubleClickResetsZoom = true;
       EnableMiddleClickPanning = true;
@@ -42,6 +40,4 @@
     [DefaultValue(true)]
     public bool EnableMiddleClickPanning { get; set; }
-    [DefaultValue(false)]
-    public bool ShowPropertiesContextMenuItem { get; set; }
 
     public static void CustomizeChartArea(ChartArea chartArea) {
@@ -142,9 +138,4 @@
     #endregion
 
-    private void contextMenuStrip_Opening(object sender, CancelEventArgs e) {
-      propertiesToolStripSeparator.Visible = ShowPropertiesContextMenuItem;
-      propertiesToolStripMenuItem.Visible = ShowPropertiesContextMenuItem;
-    }
-
     private void exportChartToolStripMenuItem_Click(object sender, System.EventArgs e) {
       // Set image file format
@@ -177,14 +168,4 @@
       Clipboard.SetDataObject(bmp);
     }
-
-    private void propertiesToolStripMenuItem_Click(object sender, EventArgs e) {
-      OnPropertiesClicked();
-    }
-
-    public event EventHandler PropertiesClicked;
-    private void OnPropertiesClicked() {
-      var handler = PropertiesClicked;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
   }
 }