Index: /trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLab.Tracing-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLab.Tracing-3.3.csproj	(revision 6178)
+++ /trunk/sources/HeuristicLab.Tracing/3.3/HeuristicLab.Tracing-3.3.csproj	(revision 6179)
@@ -114,9 +114,4 @@
     <Compile Include="Logger.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Properties\Settings.Designer.cs">
-      <AutoGen>True</AutoGen>
-      <DesignTimeSharedInput>True</DesignTimeSharedInput>
-      <DependentUpon>Settings.settings</DependentUpon>
-    </Compile>
   </ItemGroup>
   <ItemGroup>
@@ -130,8 +125,4 @@
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />
-    <None Include="Properties\Settings.settings">
-      <Generator>SettingsSingleFileGenerator</Generator>
-      <LastGenOutput>Settings.Designer.cs</LastGenOutput>
-    </None>
   </ItemGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Tracing/3.3/Logger.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tracing/3.3/Logger.cs	(revision 6178)
+++ /trunk/sources/HeuristicLab.Tracing/3.3/Logger.cs	(revision 6179)
@@ -38,5 +38,5 @@
     public static void Debug(object message) {
       StackFrame frame = new StackFrame(1);
-      Trace.TraceInformation(frame.GetMethod().DeclaringType.ToString() + " - " + message.ToString());
+      Trace.TraceInformation("{0} - {1}", frame.GetMethod().DeclaringType, message);
     }
 
@@ -47,5 +47,5 @@
     public static void Info(object message) {
       StackFrame frame = new StackFrame(1);
-      Trace.TraceInformation(frame.GetMethod().DeclaringType.ToString() + " - " + message.ToString());
+      Trace.TraceInformation("{0} - {1}", frame.GetMethod().DeclaringType, message);
     }
 
@@ -56,5 +56,5 @@
     public static void Warn(object message) {
       StackFrame frame = new StackFrame(1);
-      Trace.TraceWarning(frame.GetMethod().DeclaringType.ToString() + " - " + message.ToString());
+      Trace.TraceWarning("{0} - {1}", frame.GetMethod().DeclaringType, message);
     }
 
@@ -65,5 +65,5 @@
     public static void Error(object message) {
       StackFrame frame = new StackFrame(1);
-      Trace.TraceError(frame.GetMethod().DeclaringType.ToString() + " - " + message.ToString());
+      Trace.TraceError("{0} - {1}", frame.GetMethod().DeclaringType, message);
     }
 
@@ -74,5 +74,5 @@
     /// <param name="message">The message.</param>
     public static void Debug(Type type, object message) {
-      Trace.TraceInformation(type.ToString() + ": " + message.ToString());
+      Trace.TraceInformation("{0}: {1}", type, message);
     }
 
@@ -83,5 +83,5 @@
     /// <param name="message">The message.</param>
     public static void Info(Type type, object message) {
-      Trace.TraceInformation(type.ToString() + ": " + message.ToString());
+      Trace.TraceInformation("{0}: {1}", type, message);
     }
 
@@ -92,5 +92,5 @@
     /// <param name="message">The message.</param>
     public static void Warn(Type type, object message) {
-      Trace.TraceWarning(type.ToString() + ": " + message.ToString());
+      Trace.TraceWarning("{0}: {1}", type, message);
     }
 
@@ -101,5 +101,5 @@
     /// <param name="message">The message.</param>
     public static void Error(Type type, object message) {
-      Trace.TraceError(type.ToString() + ": " + message.ToString());
+      Trace.TraceError("{0}: {1}", type, message);
     }
 
@@ -110,5 +110,5 @@
     /// <param name="exception">The exception.</param>
     public static void Debug(object message, Exception exception) {
-      Trace.TraceInformation(message.ToString() + ": " + exception.ToString());
+      Trace.TraceInformation("{0}: {1}:", message, exception);
     }
 
@@ -119,5 +119,5 @@
     /// <param name="exception">The exception.</param>        
     public static void Info(object message, Exception exception) {
-      Trace.TraceInformation(message.ToString() + ": " + exception.ToString());
+      Trace.TraceInformation("{0}: {1}:", message, exception);
     }
 
@@ -128,5 +128,5 @@
     /// <param name="exception">The exception.</param>
     public static void Warn(object message, Exception exception) {
-      Trace.TraceWarning(message.ToString() + ": " + exception.ToString());
+      Trace.TraceWarning("{0}: {1}:", message, exception);
     }
 
@@ -137,5 +137,5 @@
     /// <param name="exception">The exception.</param>
     public static void Error(object message, Exception exception) {
-      Trace.TraceError(message.ToString() + ": " + exception.ToString());
+      Trace.TraceError("{0}: {1}:", message, exception);
     }
 
@@ -147,5 +147,5 @@
     /// <param name="exception">The exception.</param>
     public static void Debug(Type type, object message, Exception exception) {
-      Trace.TraceInformation(type.ToString() + ": " + message.ToString() + ": " + exception.ToString());
+      Trace.TraceInformation("{0}: {1}: {2}", type, message, exception);
     }
 
@@ -157,5 +157,5 @@
     /// <param name="exception">The exception.</param>
     public static void Info(Type type, object message, Exception exception) {
-      Trace.TraceInformation(type.ToString() + ": " + message.ToString() + ": " + exception.ToString());
+      Trace.TraceInformation("{0}: {1}: {2}", type, message, exception);
     }
 
@@ -167,5 +167,5 @@
     /// <param name="exception">The exception.</param>
     public static void Warn(Type type, object message, Exception exception) {
-      Trace.TraceWarning(type.ToString() + ": " + message.ToString() + ": " + exception.ToString());
+      Trace.TraceWarning("{0}: {1}: {2}", type, message, exception);
     }
 
@@ -177,5 +177,5 @@
     /// <param name="exception">The exception.</param>
     public static void Error(Type type, object message, Exception exception) {
-      Trace.TraceError(type.ToString() + ": " + message.ToString() + ": " + exception.ToString());
+      Trace.TraceError("{0}: {1}: {2}", type, message, exception);
     }
   }
Index: unk/sources/HeuristicLab.Tracing/3.3/Properties/Settings.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tracing/3.3/Properties/Settings.Designer.cs	(revision 6178)
+++ 	(revision )
@@ -1,26 +1,0 @@
-﻿//------------------------------------------------------------------------------
-// <auto-generated>
-//     This code was generated by a tool.
-//     Runtime Version:4.0.30319.225
-//
-//     Changes to this file may cause incorrect behavior and will be lost if
-//     the code is regenerated.
-// </auto-generated>
-//------------------------------------------------------------------------------
-
-namespace HeuristicLab.Tracing.Properties {
-    
-    
-    [global::System.Runtime.CompilerServices.CompilerGeneratedAttribute()]
-    [global::System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.VisualStudio.Editors.SettingsDesigner.SettingsSingleFileGenerator", "10.0.0.0")]
-    internal sealed partial class Settings : global::System.Configuration.ApplicationSettingsBase {
-        
-        private static Settings defaultInstance = ((Settings)(global::System.Configuration.ApplicationSettingsBase.Synchronized(new Settings())));
-        
-        public static Settings Default {
-            get {
-                return defaultInstance;
-            }
-        }
-    }
-}
Index: unk/sources/HeuristicLab.Tracing/3.3/Properties/Settings.settings
===================================================================
--- /trunk/sources/HeuristicLab.Tracing/3.3/Properties/Settings.settings	(revision 6178)
+++ 	(revision )
@@ -1,7 +1,0 @@
-﻿<?xml version='1.0' encoding='utf-8'?>
-<SettingsFile xmlns="http://schemas.microsoft.com/VisualStudio/2004/01/settings" CurrentProfile="(Default)" GeneratedClassNamespace="HeuristicLab.Tracing.Properties" GeneratedClassName="Settings">
-  <Profiles />
-  <Settings>
-   
-  </Settings>
-</SettingsFile>
Index: /trunk/sources/HeuristicLab.Tracing/3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Tracing/3.3/app.config	(revision 6178)
+++ /trunk/sources/HeuristicLab.Tracing/3.3/app.config	(revision 6179)
@@ -11,13 +11,3 @@
     </trace>
   </system.diagnostics>
-  <configSections>    
-    <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
-      <section name="HeuristicLab.Tracing.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false"/>
-    </sectionGroup>
-  </configSections>
-  <userSettings>
-    <HeuristicLab.Tracing.Properties.Settings>
-    
-    </HeuristicLab.Tracing.Properties.Settings>
-  </userSettings>
 <startup><supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0"/></startup></configuration>